from flask import Flask, url_for, request, render_template, make_response, escape, session, redirect, jsonify, abort
import werkzeug
import json
import logging
import os
import uuid
import datetime
import re

app = Flask(__name__)
app.secret_key = str(os.urandom(16))

#logginglevel = logging.INFO
logginglevel = logging.ERROR
logging.basicConfig(filename="/tmp/appmailserver.log",
                level=logginglevel,
                style="{",
                format="{asctime} [{levelname:8}] [{funcName:25}] {message}")

class userparam:
    def addRow(self, row):
        self.row = row
        
    def setUsername(self, name):
        self.name = name

    def setUid(self, uid):
        self.uid = uid
        
    def setEnabled(self, enabled):
        self.enabled = enabled
        
    def setMailaddress(self, mailaddress):
        self.mailaddress = mailaddress
        
    def getUsername(self):
        return self.name
    
    def getMailaddress(self):
        return self.mailaddress

    def getUid(self):
        return self.uid
    
    def getEnabled(self):
        return self.enabled
    
    def getRow(self):
        return self.row

# -------------------------------------------------------------    
@app.route("/login")
def login():
    logging.info("login")
    return render_template("login.html")

@app.route("/loginuser", methods = ["POST"])
def loginuser():
    logging.info("loginuser")
    inputuser =  request.form["username"]
    logging.info(inputuser)
    inputpassword = request.form["password"]
    logging.info(inputpassword)
    user, password = getUser()
    if user == inputuser:
        filelist = getFilename("password", ".list")
        command = "mpassword " + inputpassword + " > " + filelist
        logging.info(command)
        if runCommand(command):
            with open(filelist) as flist:
                lines = flist.readlines()
            for line in lines:
                line = line.strip()
                inputpassword = line
        logging.info(inputpassword)
        logging.info(password)
        if inputpassword == password:
            session["username"] = user
            return redirect("/user")
    message = "User name or password wrong"
    return render_template("login.html", message=message)

# -------------------------------------------------------------    
# user
@app.route("/user")
def user():
    logging.info("user")
    checkSession()
    userlist = []
    filelist = getFilename("userlist", ".list")
    command = "sudo mgetusers > " + filelist
    if runCommand(command):
        with open(filelist) as flist:
            lines = flist.readlines()
        
        index = 0
        row = 0
        for line in lines:
            line = line.strip()
            if index == 0:
                user = userparam()
                user.addRow(row)
                user.setUsername(line)
            if index == 1:
                user.setMailaddress(line)
            if index == 2:
                user.setUid(line)
            if index == 3:
                if line == "A":
                    user.setEnabled("checked")
                else:
                    user.setEnabled("")
                print(user.getUsername())
                userlist.append(user)
                index = -1
                row = row + 1
            index = index + 1
    return render_template("user.html", userlist=userlist, message="")

# edit user
@app.route("/edituser", methods=["POST"])
def edituser():
    logging.info("edituser")
    checkSession()
    try:
        value = request.form["edit"]
    except:
        value = request.form["new"]
    logging.info(value)
    
    if value == "New User":
        return render_template("newuser.html")
    else:
        filelist = getFilename("edituser", ".user")
        command = "sudo mgetuser " + value + " > " + filelist
        if runCommand(command):
            with open(filelist) as flist:
                lines = flist.readlines()
            
            index = 0
            for line in lines:
                line = line.strip()
                logging.info(line)
                if index == 0:
                    username = line
                if index == 1:
                    emailaddress = line.split("@")
                    emailaddress = emailaddress[0]
                if index == 2:
                    uid = line
                if index == 3:
                    if line == "A":
                        checked = "checked"
                    else:
                        checked = ""
                index = index + 1
                if index > 3:
                    index = 0
        return render_template("edituser.html", username=username, emailaddress=emailaddress, uid=uid, checked=checked)

@app.route("/saveuser", methods=["POST"])
def saveuser():
    logging.info("saveuser")
    checkSession()
    username = request.form["username"]
    logging.info(username)
    newemailaddress = request.form["emailaddress"]
    logging.info(newemailaddress)
    userpassword = request.form["userpassword"]
    logging.info(userpassword)
    poppassword = request.form["poppassword"]
    logging.info(poppassword)
    imappassword = request.form["imappassword"]
    logging.info(imappassword)
    archivpassword = request.form["archivpassword"]
    logging.info(archivpassword)
    result = validatepasswords(userpassword, poppassword, imappassword, archivpassword)
    if result is not None:
        return jsonify(result)
    if newemailaddress == "":
        return jsonify("error: Email address required")
    if "@" in newemailaddress:
        return jsonify("error: Email address without domain")
    
    emailaddress = ""
    filelist = getFilename("saveuser", ".user")
    command = "sudo mgetuser  " + username + " > " + filelist
    if runCommand(command):
        with open(filelist) as flist:
            lines = flist.readlines()
        emailaddress = lines[1]
        emailaddressa = emailaddress.split("@")
        emailaddress = emailaddress[0]
                
    command = "sudo medituser -u " + username
    if emailaddress != newemailaddress:
        command = command + " -e " + newemailaddress
    if userpassword != "":
        command = command + " -p '" + userpassword + "'"
    if poppassword != "":
        command = command + " -o '" + poppassword + "'"
    if imappassword != "":
        command = command + " -i '" + imappassword + "'"
    if archivpassword != "":
        command = command + " -i '" + archivpassword + "'"
    logging.info(command)
    if not runCommand(command):
        message = "error: Cannot execute " + command
        return render_template("edituser.html", message=message)
    
    newenable = request.form.get("enable", default=False, type=bool)
    command = "misenable -q -u " + username
    logging.info(command)
    enable = os.system(command)
    if enable != newenable:
        if newenable:
            command = "menable -q -u " + username
        else:
            command = "mdisable -q -u " + username
        logging.info(command)
        message = "error: Cannot execute " + command
        if not runCommand(command):
            message = "error: Cannot execute " + command
            return render_template("edituser.html", message=message)
    return redirect ("/user")

@app.route("/savenewuser", methods=["POST"])
def savenewuser():
    logging.info("savenewuser")
    checkSession()
    username = request.form["username"]
    emailaddress = request.form["emailaddress"]
    uid = request.form["uid"]
    userpassword = request.form["userpassword"]
    logging.info(userpassword)
    poppassword = request.form["poppassword"]
    logging.info(poppassword)
    imappassword = request.form["imappassword"]
    logging.info(imappassword)
    archivpassword = request.form["archivpassword"]
    logging.info(archivpassword)
    logging.info(username)
    if username == "" or emailaddress == "" or userpassword == "" or poppassword == "" or imappassword == ""  or archivpassword == "":
        return jsonify("error: User name, Mail address, User, POP3, IMAP and archiv password required")
    if not validateusername(username):
        return jsonify("error: User name: Lowercase letters and numbers only")
    result = validatepasswords(userpassword, poppassword, imappassword, archivpassword)
    logging.info(result)
    if result is not None:
        return jsonify(result)
    if "@" in emailaddress:
        return jsonify("error: Email address without domain")    
    command = "sudo madduser -q -u " + username + " -p '" + userpassword + "' -e " + emailaddress + " -o '" + poppassword + "' -i '" + imappassword + "' -a '" + archivpassword + "'"
    if uid != "":
        command = command + " -g " + uid
    logging.info(command)
    if not runCommand(command):
        message = "error: Cannot execute " + command
        return render_template("alert.html", message=message)
    return redirect ("/user")

def validatepasswords(newuserpassword, newpoppassword, newimappassword, newarchivpassword):
    newuserpassword = request.form["userpassword"]
    if newuserpassword != "":
        if not checkpasswd(newuserpassword):
            return "error: User password wrong"
            
    newpoppassword = request.form["poppassword"]
    if newpoppassword != "":
        if not checkpasswd(newpoppassword):
            return "error: POP password wrong"
        
    newimappassword = request.form["imappassword"]
    if newimappassword != "":
        if not checkpasswd(newimappassword):
            return "error: IMAP password wrong"
        
    newarchivpassword = request.form["archivpassword"]
    if newarchivpassword != "":
        if not checkpasswd(newarchivpassword):
            return "error: Archiv password wrong"
    
# -------------------------------------------------------------    
# SMTP
@app.route("/editsmtp")
def editsmtp():
    logging.info("editsmtp")
    checkSession()
    smtpa = getSystemValue("mgetrelayhost")
    if not smtpa:
        message = "Cannot execute mgetrelayhost"
        return render_template("alert.html", message=message)
    smtpserver = smtpa[0]
    smtpserver = smtpserver.strip()
    mailaddressa = getSystemValue("mgetsmtp")
    if not mailaddressa:
        message = "Cannot execute mgetsmtp"
        return render_template("alert.html", message=message)
    mailaddress = mailaddressa[0]
    mailaddress = mailaddress.strip()
    passworda = getSystemValue("mgetsmtppasswd")
    if not passworda:
        message = "Cannot execute mgetsmtppasswd"
        return render_template("alert.html", message=message)
    password = passworda[0]
    password = password.strip()
    return render_template("editsmtp.html", smtpserver=smtpserver, mailaddress=mailaddress, password=password)

@app.route("/savesmtp", methods=["POST"])
def savesmtp():
    logging.info("savesmtp")
    checkSession()
    smtpserver = request.form["smtpserver"]
    mailaddress = request.form["mailaddress"]
    password = request.form["password"]
    command = "sudo msetsmtp -q -r " + smtpserver + " -e " + mailaddress + " -p '" + password + "'"
    logging.info(command)
    if not runCommand(command):
        message = "Cannot execute " + command
        return render_template("alert.html", message=message)
    command = "sudo msetrelayhost " + smtpserver 
    logging.info(command)
    if not runCommand(command):
        message = "Cannot execute " + command
        return render_template("alert.html", message=message)
    return redirect ("/user")

# -------------------------------------------------------------    
# pop3
@app.route("/editpop")
def editpop():
    logging.info("editpop")
    checkSession()
    popa = getSystemValue("sudo mgetpop")
    logging.info(popa)
    if not popa:
        message = "Cannot execute mgetpop"
        return render_template("alert.html", message=message)
    pop = popa[0]
    pop = pop.strip()
    help = "change /etc/fetchmailrc"
    return render_template("editpop.html", pop=pop, help=help)

@app.route("/savepop", methods=["POST"])
def savepop():
    logging.info("savepop")
    checkSession()
    pop = request.form["pop"]
    command = "sudo msetpopserver " + pop  
    logging.info(command)
    if not runCommand(command):
        message = "Cannot execute " + command
        return render_template("alert.html", message=message)
    return redirect ("/user")

# -------------------------------------------------------------    
# domain
@app.route("/editdomain")
def editdomain():
    logging.info("editdomain")
    checkSession()
    domaina = getSystemValue("mgetdomain")
    if not domaina:
        message = "Cannot execute mgetdomain"
        return render_template("alert.html", message=message)
    domain = domaina[0]
    domain = domain.strip()
    return render_template("editdomain.html", domain=domain)

@app.route("/savedomain", methods=["POST"])
def savedomain():
    logging.info("savedomain")
    checkSession()
    domain = request.form["domain"]
    command = "sudo msetdomain " + domain
    logging.info(command)
    if not runCommand(command):
        message = "Cannot execute " + command
        return render_template("alert.html", message=message)
    return redirect ("/user")

# -------------------------------------------------------------    
# Restart
@app.route("/restart")
def restart():
    logging.info("restart")
    checkSession()
    postfixa = getSystemValue("mispostfix")
    postfix = postfixa[0]
    postfix = postfix.strip()
    logging.info(postfix)
    postfix = "Postfix " + postfix
    if not postfix:
        message = "Cannot execute " + command
        return render_template("alert.html", message=message)        
    fetchmaila = getSystemValue("misfetchmail")
    fetchmail = fetchmaila[0]
    fetchmail = fetchmail.strip()
    logging.info(fetchmail)
    if not fetchmail:
        message = "Cannot execute " + command
        return render_template("alert.html", message=message)
    fetchmail = "Fetchmail " + fetchmail
    return render_template("restart.html", postfix=postfix, fetchmail=fetchmail)

@app.route("/startstop", methods = ["POST"])
def startstop():
    checkSession()
    logging.info("startstop")
    inputpassword = request.form["password"]
    logging.info(inputpassword)
    button = request.form["button"]
    logging.info(button)
    if button == "stoppostfix" or button == "startpostfix":
        rcommand = "postfix"
    if button == "stopfetchmail" or button == "startfetchmail":
        rcommand = "fetchmail"
    if button.startswith("stop"):
        command = "sudo systemctl stop " + rcommand
    if button.startswith("start"):
        command = "sudo systemctl restart " + rcommand
    if button == "restart" or button == "shutdown":
        if inputpassword != "":
            filelist = getFilename("password", ".list")
            command = "mpassword " + inputpassword + " > " + filelist
            logging.info(command)
            if runCommand(command):
                with open(filelist) as flist:
                    lines = flist.readlines()
                for line in lines:
                    line = line.strip()
                    inputpassword = line
        logging.info(inputpassword)
        user, password = getUser()
        if password != inputpassword:
            return jsonify("error: password wrong")
    if button == "shutdown":
        command = "sudo systemctl poweroff"
    if button == "restart":
        command = "sudo systemctl reboot"
    logging.info(command)
    runCommand(command)
    filelist = getFilename("startstop", ".user")
    command = "sudo systemctl status " + rcommand + " > " + filelist
    logging.info(command)
    runCommand(command)
    with open(filelist) as flist:
        message = flist.readlines()
    return jsonify(message)

# -------------------------------------------------------------    
# Log
@app.route("/log")
def log():
    logging.info("log")
    checkSession()
    return render_template("log.html")

@app.route("/logfile", methods = ["POST"])
def logfile():
    logging.info("logfile")
    checkSession()
    button = request.form["button"]
    logging.info(button)
    if button == "fetchmail":
        command = "mlogfetchmail"
    if button == "mail":
        command = "mlogmail"
    filelist = getFilename("log", ".user")
    command = "sudo " + command + " > " + filelist
    logging.info(command)
    runCommand(command)
    with open(filelist) as flist:
        message = flist.readlines()
    return jsonify(message)

# -------------------------------------------------------------    
# Share calendar
@app.route("/calendar")
def calendar():
    logging.info("calendar")
    checkSession()
    filelist = getFilename("calendar", ".user")
    command = "sudo mlistcalendars > " + filelist
    logging.info(command)
    runCommand(command)
    with open(filelist) as flist:
        lines = flist.readlines()
        email = []
        name = []
        calendarid = []
        firstline = True
        for line in lines:
            if not firstline:
                values = line.split()
                if values[1] != "Default":
                    email.append(values[0])
                    name.append(values[1])
                    calendarid.append(values[2])
            firstline = False
    return render_template("calendar.html", email=email, name=name, calendarid=calendarid, rows=len(email))

@app.route("/savecalendar", methods = ["POST"])
def savecalendar():
    logging.info("savecalendar")
    checkSession()
    mailaddress = request.form["mailaddress"]
    logging.info(mailaddress)
    calendarname = request.form["calendarname"]
    logging.info(calendarname)
    remove = request.form.get("remove", default=False, type=bool)
    logging.info(remove)
    if mailaddress == "" or calendarname == "":
        return jsonify("error: calendar name and Mail address required")
    command = "sudo miscalendar -e '" + mailaddress + "' -c " + calendarname + " -q"
    logging.info(command)
    result = runCommand(command)
    if not result:
        return jsonify("error: calendar not exists for this mail address")
    if remove:
        action = "-r"
    else:
        action = "-a"
    command = "sudo msharecalendar -e '" + mailaddress + "' -c " + calendarname + " " + action
    runCommand(command)
    return redirect ("/calendar")

# -------------------------------------------------------------    
# Settings
@app.route("/settings")
def settings():
    logging.info("settings")
    checkSession()
    return render_template("settings.html", message="")

@app.route("/savesettings", methods = ["POST"])
def savesettings():
    logging.info("savesettings")
    checkSession()
    adminname = request.form["adminname"]
    logging.info(adminname)
    password = request.form["password"]
    logging.info(password)
    if adminname == "" or password == "":
        message = "error: Admin name and password required"
        return render_template("settings.html", message=message)
    if not validateusername(adminname):
        message = "error: Admin name: Lowercase letters and numbers only"
        return render_template("settings.html", message=message)        
    if not checkpasswd(password):
        message = "error: Password wrong"
        return render_template("settings.html", message=message)
    filelist = getFilename("settings", ".user")
    command = "mpassword " + password + " > " + filelist
    logging.info(command)
    runCommand(command)
    with open(filelist) as flist:
        lines = flist.readlines()
    for line in lines:
        password = line.strip()
    logging.info(password)
    file = open("/mailserver/mailadmin.ini", "w")
    file.write("user=" + adminname + "\n")
    file.write("password=" + password + "\n")
    file.close()
    return redirect ("/user")

# -------------------------------------------------------------    
# Logout
@app.route("/logout")
def logout():
    logging.info("logout")
    session.clear()
    return redirect("/login")

# -----------------------------------------------------------------------
def checkSession():
    logging.info("checksession")
    if "username" in session:
        logging.info(session["username"])
        return
    return abort(403, "You must first login")

def checkpasswd(password):
    if len(password) < 10:
        return False
    if not re.findall("[A-Z]", password):
        return False
    if not re.findall("[a-z]", password):
        return False
    # digits
    if not re.findall("\d", password):
        return False
    # non-alphanumeric character
    if not re.findall("\W", password):
        return False
    return True

def validateusername(username):
    if not re.findall("^[a-z]", username):
        return False
    if re.findall("[A-Z]", username):
        return False
    # non-alphanumeric character
    if re.findall("\W", username):
        return False
    return True

def getFilename(suffix, prefix):
    filename = "/tmp/" + suffix + str(uuid.uuid4()) + prefix
    logging.info(filename)
    return filename

def getUser():
    user = ""
    password = ""
    with open("/mailserver/mailadmin.ini") as flist:
        lines = flist.readlines()
        for line in lines:
            line = line.strip()
            if line.startswith("user="):
                usera = line.split("=")
                user = usera[1]
                logging.info(user)
            if line.startswith("password="):
                passworda = line.split("=")
                password = passworda[1]
                logging.info(password)
    return user, password
    
def runCommand(command):
    print(command)
    logging.info("runCommand")
    logging.info(command)
    result = os.system(command)
    logging.info(result)
    return True

def getSystemValue(command):
    filelist = getFilename(session["username"], ".command")
    command = command + " > " + filelist
    if runCommand(command):
        with open(filelist) as flist:
            lines = flist.readlines()
        return lines
    return False
            
if __name__=="__main__":
    app.run(debug=True, threaded=True)
    pass
